Index: trunk/SophyaLib/HiStats/histos2.h
===================================================================
--- trunk/SophyaLib/HiStats/histos2.h	(revision 1089)
+++ trunk/SophyaLib/HiStats/histos2.h	(revision 1092)
@@ -28,23 +28,23 @@
 
   // CREATOR / DESTRUCTOR
-  Histo2D(float xMin, float xMax, int nxBin
-         ,float yMin, float yMax, int nyBin);
+  Histo2D(r_8 xMin,r_8 xMax,int_4 nxBin,r_8 yMin,r_8 yMax,int_4 nyBin);
+  Histo2D(r_4 xMin,r_4 xMax,int_4 nxBin,r_4 yMin,r_4 yMax,int_4 nyBin);
   Histo2D(const Histo2D& h);
   Histo2D();
-  virtual  ~Histo2D();
+  virtual ~Histo2D();
 
   // OPTIONS
-  void   Errors();  
+  void Errors();  
   
   // UPDATING
-  void   Zero();
-  void   Add(float x, float y, float w = 1.);
+  void Zero();
+  void Add(r_8 x, r_8 y, r_8 w = 1.);
 
   // Operators
   Histo2D& operator = (const Histo2D& h);
-  Histo2D& operator *= (double b);
-  Histo2D& operator /= (double b);
-  Histo2D& operator += (double b);
-  Histo2D& operator -= (double b);
+  Histo2D& operator *= (r_8 b);
+  Histo2D& operator /= (r_8 b);
+  Histo2D& operator += (r_8 b);
+  Histo2D& operator -= (r_8 b);
   Histo2D& operator += (const Histo2D& a);
   Histo2D& operator -= (const Histo2D& a);
@@ -58,6 +58,6 @@
   void GetError2(TMatrix<r_8>& v);
   void GetError(TMatrix<r_8>& v);
-  void PutValue(TMatrix<r_8>& v, int ierr=0);
-  void PutValueAdd(TMatrix<r_8>& v, int ierr=0);
+  void PutValue(TMatrix<r_8>& v, int_4 ierr=0);
+  void PutValueAdd(TMatrix<r_8>& v, int_4 ierr=0);
   void PutError2(TMatrix<r_8>& v);
   void PutError2Add(TMatrix<r_8>& v);
@@ -66,125 +66,134 @@
   // INLINES
   //! Retourne l'abscisse minimum.
-  inline float   XMin() const {return xmin;}
+  inline r_8 XMin() const {return mXmin;}
   //! Retourne l'abscisse maximum.
-  inline float   XMax() const {return xmax;}
+  inline r_8 XMax() const {return mXmax;}
   //! Retourne l'ordonnee minimum.
-  inline float   YMin() const {return ymin;}
+  inline r_8 YMin() const {return mYmin;}
   //! Retourne l'ordonnee maximum.
-  inline float   YMax() const {return ymax;}
+  inline r_8 YMax() const {return mYmax;}
   //! Retourne le nombre de bins selon X.
-  inline int_4   NBinX() const {return nx;}
+  inline int_4 NBinX() const {return mNx;}
   //! Retourne le nombre de bins selon Y.
-  inline int_4   NBinY() const {return ny;}
+  inline int_4 NBinY() const {return mNy;}
   //! Retourne la largeur du bin selon X.
-  inline float   WBinX() const {return wbinx;}
+  inline r_8 WBinX() const {return mWBinx;}
   //! Retourne la largeur du bin selon Y.
-  inline float   WBinY() const {return wbiny;}
+  inline r_8 WBinY() const {return mWBiny;}
   //! Retourne le pointeur sur le tableaux des contenus.
-  inline float*  Bins() const  {return data;}
+  inline r_8* Bins() const  {return mData;}
   //! Retourne le contenu du bin i,j.
-  inline float   operator()(int i,int j) const {return data[j*nx+i];}
+  inline r_8 operator()(int_4 i,int_4 j) const {return mData[j*mNx+i];}
   //! Remplit le contenu du bin i,j.
-  inline float&  operator()(int i,int j)       {return data[j*nx+i];}
+  inline r_8& operator()(int_4 i,int_4 j)      {return mData[j*mNx+i];}
   //! retourne "true" si il y a des erreurs stoquees
-  inline bool    HasErrors() { if(err2) return true; else return false;}
+  inline bool HasErrors() { if(mErr2) return true; else return false;}
   //! Retourne l'erreur du bin i,j.
-  inline float   Error(int i,int j)  const
-                   {if(err2)
-                      {if(err2[j*nx+i]>0.) return sqrt(err2[j*nx+i]); else return 0.;}
-                    else return 0.;}
+  inline r_8 Error(int_4 i,int_4 j)  const
+    {if(mErr2)
+       {if(mErr2[j*mNx+i]>0.) return sqrt(mErr2[j*mNx+i]); else return 0.;}
+     else return 0.;}
   //! Remplit l'erreur au carre du bin i,j.
-  inline double  Error2(int i,int j) const
-                   {if(err2) return err2[j*nx+i]; else return 0.;}
+  inline r_8 Error2(int_4 i,int_4 j) const
+             {if(mErr2) return mErr2[j*mNx+i]; else return 0.;}
   //! Remplit l'erreur au carre du bin i,j.
-  inline double& Error2(int i,int j) {return err2[j*nx+i];}
+  inline r_8& Error2(int_4 i,int_4 j) {return mErr2[j*mNx+i];}
   //! Retourne la somme ponderee.
-  inline float   NData() const    {return (float) nHist;}
+  inline r_8 NData() const    {return nHist;}
   //! Retourne le nombre d'entrees.
-  inline int_4   NEntries() const {return nEntries;}
+  inline int_4 NEntries() const {return nEntries;}
   //! Retourne l'abscisse et l'ordonnee du coin inferieur du bin i,j.
-  inline void BinLowEdge(int i,int j,float& x,float& y)
-                 {x = xmin + i*wbinx; y = ymin + j*wbiny;}
+  inline void BinLowEdge(int_4 i,int_4 j,r_8& x,r_8& y)
+              {x = mXmin + i*mWBinx; y = mYmin + j*mWBiny;}
+  //! Retourne l'abscisse et l'ordonnee du coin inferieur du bin i,j.
+  inline void BinLowEdge(int_4 i,int_4 j,r_4& xf,r_4& yf)
+              {r_8 x,y; BinLowEdge(i,j,x,y); xf=x; yf=y;}
   //! Retourne l'abscisse et l'ordonnee du centre du bin i,j.
-  inline void BinCenter(int i,int j,float& x,float& y)
-                 {x = xmin + (i+0.5)*wbinx; y = ymin + (j+0.5)*wbiny;}
+  inline void BinCenter(int_4 i,int_4 j,r_8& x,r_8& y)
+              {x = mXmin + (i+0.5)*mWBinx; y = mYmin + (j+0.5)*mWBiny;}
+  //! Retourne l'abscisse et l'ordonnee du centre du bin i,j.
+  inline void BinCenter(int_4 i,int_4 j,r_4& xf,r_4& yf)
+              {r_8 x,y; BinCenter(i,j,x,y); xf=x; yf=y;}
   //! Retourne l'abscisse et l'ordonnee du coin superieur du bin i,j.
-  inline void BinHighEdge(int i,int j,float& x,float& y)
-                 {x = xmin + (i+1)*wbinx; y = ymin + (j+1)*wbiny;}
+  inline void BinHighEdge(int_4 i,int_4 j,r_8& x,r_8& y)
+              {x = mXmin + (i+1)*mWBinx; y = mYmin + (j+1)*mWBiny;}
+  //! Retourne l'abscisse et l'ordonnee du coin superieur du bin i,j.
+  inline void BinHighEdge(int_4 i,int_4 j,r_4& xf,r_4& yf)
+              {r_8 x,y; BinHighEdge(i,j,x,y); xf=x; yf=y;}
   //! Retourne les numeros du bin contenant l'abscisse et l'ordonnee x,y.
-  inline void FindBin(float x,float y,int& i,int& j)
-    { i = (int) floorf((x - xmin)/wbinx); j = (int) floorf((y - ymin)/wbiny);}
+  inline void FindBin(r_8 x,r_8 y,int_4& i,int_4& j)
+    {i=(int_4) floor((x-mXmin)/mWBinx); j=(int_4) floor((y-mYmin)/mWBiny);}
 
   // Info, statistique et calculs sur les histogrammes
-  float   NOver(int i=-1,int j=-1) const;
-  int     BinNonNul() const;
-  int     ErrNonNul() const;
-  void    IJMax(int& imax,int& jmax,int il=1,int ih= -1,int jl=1,int jh= -1);
-  void    IJMin(int& imax,int& jmax,int il=1,int ih= -1,int jl=1,int jh= -1);
-  float   VMax(int il=1,int ih= -1,int jl=1,int jh= -1) const;
-  float   VMin(int il=1,int ih= -1,int jl=1,int jh= -1) const;
-  int     EstimeMax(float& xm,float& ym,int SzPav = 3
-                   ,int il=1,int ih= -1,int jl=1,int jh= -1);
-  int     EstimeMax(int im,int jm,float& xm,float& ym,int SzPav = 3);
-  int     FindMax(int& im,int& jm,int SzPav = 3,float Dz = 0.
-                 ,int il=1,int ih= -1,int jl=1,int jh= -1);
+  r_8   NOver(int_4 i=-1,int_4 j=-1) const;
+  int_4 BinNonNul() const;
+  int_4 ErrNonNul() const;
+  void IJMax(int_4& imax,int_4& jmax,int_4 il=1,int_4 ih= -1,int_4 jl=1,int_4 jh= -1);
+  void IJMin(int_4& imax,int_4& jmax,int_4 il=1,int_4 ih= -1,int_4 jl=1,int_4 jh= -1);
+  r_8 VMax(int_4 il=1,int_4 ih= -1,int_4 jl=1,int_4 jh= -1) const;
+  r_8 VMin(int_4 il=1,int_4 ih= -1,int_4 jl=1,int_4 jh= -1) const;
+  int_4 EstimeMax(r_8& xm,r_8& ym,int_4 SzPav = 3
+                 ,int_4 il=1,int_4 ih= -1,int_4 jl=1,int_4 jh= -1);
+  int_4 EstimeMax(int_4 im,int_4 jm,r_8& xm,r_8& ym,int_4 SzPav = 3);
+  int_4 FindMax(int_4& im,int_4& jm,int_4 SzPav = 3,r_8 Dz = 0.
+               ,int_4 il=1,int_4 ih= -1,int_4 jl=1,int_4 jh= -1);
 
   // Fit
-  int      Fit(GeneralFit& gfit,unsigned short typ_err=0);
-  Histo2D  FitResidus(GeneralFit& gfit);
-  Histo2D  FitFunction(GeneralFit& gfit);
+  int_4   Fit(GeneralFit& gfit,unsigned short typ_err=0);
+  Histo2D FitResidus(GeneralFit& gfit);
+  Histo2D FitFunction(GeneralFit& gfit);
 
   // Print et Display ASCII
-  void    PrintStatus();
-  void    Print(float min=1.,float max=-1.
-               ,int il=1,int ih= -1,int jl=1,int jh= -1);
+  void PrintStatus();
+  void Print(r_8 min=1.,r_8 max=-1.
+               ,int_4 il=1,int_4 ih= -1,int_4 jl=1,int_4 jh= -1);
 
   // PROJECTIONS
-  void           SetProjX();
-  void           SetProjY();
-  void           SetProj();
-  void           DelProjX();
-  void           DelProjY();
-  void           DelProj();
-  void           ZeroProjX();
-  void           ZeroProjY();
-  void           ZeroProj();
+  void SetProjX();
+  void SetProjY();
+  void SetProj();
+  void DelProjX();
+  void DelProjY();
+  void DelProj();
+  void ZeroProjX();
+  void ZeroProjY();
+  void ZeroProj();
   //! Retourne le pointeur sur l'histo 1D de la projection selon X.
-  inline Histo*  HProjX() const {return hprojx;}
+  inline Histo* HProjX() const {return mHprojx;}
   //! Retourne le pointeur sur l'histo 1D de la projection selon Y.
-  inline Histo*  HProjY() const {return hprojy;}
-  void           ShowProj();
+  inline Histo* HProjY() const {return mHprojy;}
+  void ShowProj();
 
   // BANDES
   //! Retourne le nombre de bandes selon X
-  inline int     NBandX() const {return lbandx.size();}
+  inline int_4 NBandX() const {return mLBandx.size();}
   //! Retourne le nombre de bandes selon Y
-  inline int     NBandY() const {return lbandy.size();}
-  int            SetBandX(float ybmin,float ybmax);
-  int            SetBandY(float xbmin,float xbmax);
-  void           DelBandX();
-  void           DelBandY();
-  void           ZeroBandX();
-  void           ZeroBandY();
-  Histo*         HBandX(int n) const;
-  Histo*         HBandY(int n) const;
-  void           GetBandX(int n,float& ybmin,float& ybmax) const;
-  void           GetBandY(int n,float& xbmin,float& xbmax) const;
-  void           ShowBand(int lp = 0);
+  inline int_4 NBandY() const {return mLBandy.size();}
+  int_4 SetBandX(r_8 ybmin,r_8 ybmax);
+  int_4 SetBandY(r_8 xbmin,r_8 xbmax);
+  void DelBandX();
+  void DelBandY();
+  void ZeroBandX();
+  void ZeroBandY();
+  Histo* HBandX(int_4 n) const;
+  Histo* HBandY(int_4 n) const;
+  void GetBandX(int_4 n,r_8& ybmin,r_8& ybmax) const;
+  void GetBandY(int_4 n,r_8& xbmin,r_8& xbmax) const;
+  void ShowBand(int_4 lp = 0);
 
   // SLICES
   //! Retourne le nombre de slices selon X
-  inline int     NSliX() const {return lslix.size();}
+  inline int_4 NSliX() const {return mLSlix.size();}
   //! Retourne le nombre de slices selon Y
-  inline int     NSliY() const {return lsliy.size();}
-  int            SetSliX(int nsli);
-  int            SetSliY(int nsli);
-  void           DelSliX();
-  void           DelSliY();
-  void           ZeroSliX();
-  void           ZeroSliY();
-  Histo*         HSliX(int n) const;
-  Histo*         HSliY(int n) const;
-  void           ShowSli(int lp = 0);
+  inline int_4 NSliY() const {return mLSliy.size();}
+  int_4 SetSliX(int_4 nsli);
+  int_4 SetSliY(int_4 nsli);
+  void DelSliX();
+  void DelSliY();
+  void ZeroSliX();
+  void ZeroSliY();
+  Histo* HSliX(int_4 n) const;
+  Histo* HSliY(int_4 n) const;
+  void ShowSli(int_4 lp = 0);
 
 #ifndef __DECCXX
@@ -193,8 +202,8 @@
   //! structure de definition des bandes
   struct bande_slice {
-    int num;   //!< nombre de bandes
-    float min; //!< limite minimum pour remplir la bande
-    float max; //!< limite maximum pour remplir la bande
-    Histo* H;  //!< pointer sur l Histo 1D de la bande
+    int_4 num;   //!< nombre de bandes
+    r_8 min;     //!< limite minimum pour remplir la bande
+    r_8 max;     //!< limite maximum pour remplir la bande
+    Histo* H;    //!< pointer sur l Histo 1D de la bande
     STRUCTCOMP(bande_slice)
   };
@@ -205,31 +214,31 @@
   void Delete();
 
-  float*         data; //!< donnees
-  double*        err2; //!< erreurs carrees
-
-  float          over[3][3]; //!< overflow table
-  double         nHist;      //!< somme ponderee des entrees
-  int_4          nEntries;   //!< nombre d'entrees
-
-  int_4          nx;    //!< nombre de bins en X
-  int_4          ny;    //!< nombre de bins en Y
-  int_4          nxy;   //!< nombre de bins total
-  float          xmin;  //!< abscisse minimum
-  float          xmax;  //!< abscisse maximum
-  float          ymin;  //!< ordonnee minimum
-  float          ymax;  //!< ordonnee maximum
-  float          wbinx; //!< largeur du bin en X
-  float          wbiny; //!< largeur du bin en Y
-
-  bande_slice    b_s;
-
-  Histo*         hprojx; //!< pointer sur Histo des proj X
-  Histo*         hprojy; //!< pointer sur Histo des proj Y
-
-  list<bande_slice>  lbandx; //!< liste des bandes selon X
-  list<bande_slice>  lbandy; //!< liste des bandes selon Y
+  r_8*        mData; //!< donnees
+  r_8*        mErr2; //!< erreurs carrees
+
+  r_8         mOver[3][3]; //!< overflow table
+  r_8         nHist;       //!< somme ponderee des entrees
+  int_4       nEntries;    //!< nombre d'entrees
+
+  int_4       mNx;    //!< nombre de bins en X
+  int_4       mNy;    //!< nombre de bins en Y
+  int_4       mNxy;   //!< nombre de bins total
+  r_8         mXmin;  //!< abscisse minimum
+  r_8         mXmax;  //!< abscisse maximum
+  r_8         mYmin;  //!< ordonnee minimum
+  r_8         mYmax;  //!< ordonnee maximum
+  r_8         mWBinx; //!< largeur du bin en X
+  r_8         mWBiny; //!< largeur du bin en Y
+
+  bande_slice mB_s;
+
+  Histo*      mHprojx; //!< pointer sur Histo des proj X
+  Histo*      mHprojy; //!< pointer sur Histo des proj Y
+
+  list<bande_slice>  mLBandx; //!< liste des bandes selon X
+  list<bande_slice>  mLBandy; //!< liste des bandes selon Y
   
-  list<bande_slice>  lslix; //!< liste des slices selon X
-  list<bande_slice>  lsliy; //!< liste des slices selon Y
+  list<bande_slice>  mLSlix; //!< liste des slices selon X
+  list<bande_slice>  mLSliy; //!< liste des slices selon Y
 
 };
@@ -250,7 +259,7 @@
 // ObjFileIO<Histo2D>
 
-/*! \ingroup HiStats \fn operator*(const Histo2D&,double)
+/*! \ingroup HiStats \fn operator*(const Histo2D&,r_8)
   \brief Operateur H2 = H1 * b */
-inline Histo2D operator * (const Histo2D& a, double b)
+inline Histo2D operator * (const Histo2D& a, r_8 b)
 {
   Histo2D result(a);
@@ -258,7 +267,7 @@
 }
 
-/*! \ingroup HiStats \fn operator*(double,const Histo2D&)
+/*! \ingroup HiStats \fn operator*(r_8,const Histo2D&)
   \brief Operateur H2 = b * H1 */
-inline Histo2D operator * (double b, const Histo2D& a)
+inline Histo2D operator * (r_8 b, const Histo2D& a)
 {
   Histo2D result(a);
@@ -266,7 +275,7 @@
 }
 
-/*! \ingroup HiStats \fn operator/(const Histo2D&,double)
+/*! \ingroup HiStats \fn operator/(const Histo2D&,r_8)
   \brief Operateur H2 = H1 / b */
-inline Histo2D operator / (const Histo2D& a, double b)
+inline Histo2D operator / (const Histo2D& a, r_8 b)
 {
   Histo2D result(a);
@@ -274,7 +283,7 @@
 }
 
-/*! \ingroup HiStats \fn operator+(const Histo2D&,double)
+/*! \ingroup HiStats \fn operator+(const Histo2D&,r_8)
   \brief Operateur H2 = H1 + b */
-inline Histo2D operator + (const Histo2D& a, double b)
+inline Histo2D operator + (const Histo2D& a, r_8 b)
 {
   Histo2D result(a);
@@ -282,7 +291,7 @@
 }
 
-/*! \ingroup HiStats \fn operator+(double,const Histo2D&)
+/*! \ingroup HiStats \fn operator+(r_8,const Histo2D&)
   \brief Operateur H2 = b + H1 */
-inline Histo2D operator + (double b, const Histo2D& a)
+inline Histo2D operator + (r_8 b, const Histo2D& a)
 {
   Histo2D result(a);
@@ -290,7 +299,7 @@
 }
 
-/*! \ingroup HiStats \fn operator-(const Histo2D&,double)
+/*! \ingroup HiStats \fn operator-(const Histo2D&,r_8)
   \brief Operateur H2 = H1 - b */
-inline Histo2D operator - (const Histo2D& a, double b)
+inline Histo2D operator - (const Histo2D& a, r_8 b)
 {
   Histo2D result(a);
@@ -298,7 +307,7 @@
 }
 
-/*! \ingroup HiStats \fn operator-(double,const Histo2D&)
+/*! \ingroup HiStats \fn operator-(r_8,const Histo2D&)
   \brief Operateur H2 = b - H1 */
-inline Histo2D operator - (double b, const Histo2D& a)
+inline Histo2D operator - (r_8 b, const Histo2D& a)
 {
   Histo2D result(a);
Index: trunk/SophyaLib/HiStats/ntuple.cc
===================================================================
--- trunk/SophyaLib/HiStats/ntuple.cc	(revision 1089)
+++ trunk/SophyaLib/HiStats/ntuple.cc	(revision 1092)
@@ -324,5 +324,5 @@
 for(i=0; i<mNVar; i++) {
   GetMinMax(i, min, max);
-  sprintf(buff, "%3d  %16s  %10lg  %10lg \n", i, mNames+i*LENNAME1, min, max);
+  sprintf(buff, "%3d  %16s  %10g  %10g \n", i, mNames+i*LENNAME1, min, max);
   os << (string)buff ;
   }
Index: trunk/SophyaLib/NTools/cimage.cc
===================================================================
--- trunk/SophyaLib/NTools/cimage.cc	(revision 1089)
+++ trunk/SophyaLib/NTools/cimage.cc	(revision 1092)
@@ -5,5 +5,5 @@
 // LAL (Orsay) / IN2P3-CNRS  DAPNIA/SPP (Saclay) / CEA
 
-// $Id: cimage.cc,v 1.5 1999-10-21 15:25:42 ansari Exp $        
+// $Id: cimage.cc,v 1.6 2000-07-26 13:15:29 ansari Exp $        
 
 
@@ -723,6 +723,6 @@
 // redimensionnement de l'histo pour avoir une bonne signification stat.
 for(;;) {
-  float max1,max2;
-  int imax1,imax2;
+  r_8 max1,max2;
+  int_4 imax1,imax2;
   rc = H.MaxiLocal(max1,imax1,max2,imax2);
   float rap = 1.;
@@ -742,5 +742,5 @@
 
 TRY {
-  xbmax = H.FitMax(2,0.5f,deb-2);
+  xbmax = H.FitMax(2,0.5,deb-2);
   if(deb>1) cout<<"H.FitMax = "<<xbmax<<endl;
 } CATCHALL {
@@ -750,8 +750,9 @@
 
 TRY {
-  float sdroit = -2.;
-  H.EstimeWidthS(0.5f,sgbmax,sdroit);
-  if(sgbmax<=0.) sgbmax = H.FindWidth(0.5f,deb-2);
-  sgbmax /= 2.36;
+  r_8 sdroit = -2., dum=sgbmax;
+  H.EstimeWidthS(0.5,dum,sdroit);
+  if(dum<=0.) dum = H.FindWidth(0.5,deb-2);
+  dum /= 2.36;
+  sgbmax = dum;
   if(deb>1) cout<<"H.FindWidth = "<<sgbmax<<" (droit="<<sdroit<<")"<<endl;
 } CATCHALL {
Index: trunk/SophyaLib/NTools/perandom.cc
===================================================================
--- trunk/SophyaLib/NTools/perandom.cc	(revision 1089)
+++ trunk/SophyaLib/NTools/perandom.cc	(revision 1092)
@@ -15,5 +15,5 @@
 
 //++
-FunRan::FunRan(FunRan::Func f, float xMin, float xMax, int nBin)
+FunRan::FunRan(FunRan::Func f, r_8 xMin, r_8 xMax, int_4 nBin)
 //
 //	Createur.
@@ -22,8 +22,8 @@
 {
   (*this)(0) = f(BinLowEdge(0));
-  for(int i=1; i<nBin; i++)
+  for(int_4 i=1; i<nBin; i++)
     (*this)(i) = (*this)(i-1) + f(BinLowEdge(i));
     
-  for(int j=0; j<nBin; j++)
+  for(int_4 j=0; j<nBin; j++)
     (*this)(j) /= (*this)(nBin-1);
   END_CONSTRUCTOR
@@ -31,12 +31,12 @@
 
 //++
-FunRan::FunRan(double *tab, int nBin)
-//
-//	Createur.
-//--
-: Histo(0, (float)(nBin), nBin)
+FunRan::FunRan(r_8 *tab, int_4 nBin)
+//
+//	Createur.
+//--
+: Histo(0, (r_8)(nBin), nBin)
 {
   (*this)(0) = tab[0];
-  for(int i=1; i<nBin; i++)
+  for(int_4 i=1; i<nBin; i++)
     (*this)(i) = (*this)(i-1) + tab[i];
 
@@ -46,14 +46,14 @@
   }
 
-  for(int j=0; j<nBin; j++)
+  for(int_4 j=0; j<nBin; j++)
     (*this)(j) /= (*this)(nBin-1);
   END_CONSTRUCTOR
 }
 
-FunRan::FunRan(double *tab, int nBin, float xMin, float xMax)
+FunRan::FunRan(r_8 *tab, int_4 nBin, r_8 xMin, r_8 xMax)
 : Histo(xMin, xMax, nBin)
 {
   (*this)(0) = tab[0];
-  for(int i=1; i<nBin; i++)
+  for(int_4 i=1; i<nBin; i++)
     (*this)(i) = (*this)(i-1) + tab[i];
 
@@ -63,5 +63,5 @@
   }
 
-  for(int j=0; j<nBin; j++)
+  for(int_4 j=0; j<nBin; j++)
     (*this)(j) /= (*this)(nBin-1);
   END_CONSTRUCTOR
@@ -69,16 +69,16 @@
 
 //++
-int FunRan::BinRandom()
+int_4 FunRan::BinRandom()
 //
 //	Tirage avec retour du numero de bin.
 //--
 {
-  double z=drand01();
+  r_8 z=drand01();
   if (z <= 0) return 0;
-  if (z >= 1) return bins-1;
+  if (z >= 1) return mBins-1;
   
   // recherche du premier bin plus grand que z
-  int iBin = 0;
-  for (; iBin<bins; iBin++)
+  int_4 iBin = 0;
+  for (; iBin<mBins; iBin++)
     if (z < (*this)(iBin)) break;
 
@@ -87,31 +87,31 @@
 
 //++
-double FunRan::Random()
+r_8 FunRan::Random()
 //
 //	Tirage avec retour abscisse du bin interpole.
 //--
 {
-  double z=drand01();
-  if (z <= 0) return min;
-  if (z >= 1) return max;
+  r_8 z=drand01();
+  if (z <= 0) return mMin;
+  if (z >= 1) return mMax;
   // cas z <= tab[0] 
   if (z <= (*this)(0)) {
-    double t = min + binWidth/(*this)(0) * z;
+    r_8 t = mMin + binWidth/(*this)(0) * z;
     return t;
   }
 
   // recherche du premier bin plus grand que z
-  int iBin = 0;
-  for (; iBin<bins; iBin++)
+  int_4 iBin = 0;
+  for (; iBin<mBins; iBin++)
     if (z < (*this)(iBin)) break;
 
   // interpolation pour trouver la valeur du tirage aleatoire
-  double t1 = (*this)(iBin-1);
-  double x1 = BinLowEdge(iBin-1);
-  double t2 = (*this)(iBin);
-  double x2 = x1 + binWidth;
-  double t = x1 + (x2-x1) / (t2-t1) * (z-t1);
-  if (t < min) t = min;
-  if (t > max) t = max;
+  r_8 t1 = (*this)(iBin-1);
+  r_8 x1 = BinLowEdge(iBin-1);
+  r_8 t2 = (*this)(iBin);
+  r_8 x2 = x1 + binWidth;
+  r_8 t = x1 + (x2-x1) / (t2-t1) * (z-t1);
+  if (t < mMin) t = mMin;
+  if (t > mMax) t = mMax;
   return(t);
 }
@@ -129,5 +129,5 @@
 
 //++
-FunRan2D::FunRan2D(double *tab, int nBinX, int nBinY)
+FunRan2D::FunRan2D(r_8 *tab, int_4 nBinX, int_4 nBinY)
 //
 //	Createur.
@@ -135,8 +135,8 @@
 {
   // Tirage en X, somme sur les Y.
-   double* tabX = new double[nBinX];
-   for (int i=0; i<nBinX; i++) {
+   r_8* tabX = new r_8[nBinX];
+   for (int_4 i=0; i<nBinX; i++) {
      tabX[i] = 0;
-     for (int j=0; j<nBinY; j++) {
+     for (int_4 j=0; j<nBinY; j++) {
        tabX[i] += tab[i*nBinY +j];
      }
@@ -147,5 +147,5 @@
    ranY = new(FunRan*[nBinX]);
    
-   for (int k=0; k<nBinX; k++)
+   for (int_4 k=0; k<nBinX; k++)
       ranY[k] = new FunRan(tab + nBinY*k, nBinY);
    
@@ -155,5 +155,5 @@
 
 //++
-FunRan2D::FunRan2D(double **tab, int nBinX, int nBinY)
+FunRan2D::FunRan2D(r_8 **tab, int_4 nBinX, int_4 nBinY)
 //
 //	Createur.
@@ -161,8 +161,8 @@
 {
   // Tirage en X, somme sur les Y.
-   double* tabX = new double[nBinX];
-   for (int i=0; i<nBinX; i++) {
+   r_8* tabX = new r_8[nBinX];
+   for (int_4 i=0; i<nBinX; i++) {
      tabX[i] = 0;
-     for (int j=0; j<nBinY; j++) {
+     for (int_4 j=0; j<nBinY; j++) {
        tabX[i] += tab[i][j];
      }
@@ -172,5 +172,5 @@
    ranY = new(FunRan*[nBinX]);
    
-   for (int k=0; k<nBinX; k++)
+   for (int_4 k=0; k<nBinX; k++)
     if (tabX[k] != 0) 
       ranY[k] = new FunRan(tab[k], nBinY);
@@ -184,5 +184,5 @@
 FunRan2D::~FunRan2D()
 {
-  for (int i=nx-1; i>=0; i--)
+  for (int_4 i=nx-1; i>=0; i--)
     delete ranY[i];
     
@@ -193,5 +193,5 @@
 
 //++
-void FunRan2D::BinRandom(int& x, int& y)
+void FunRan2D::BinRandom(int_4& x, int_4& y)
 //
 //	Tirage avec retour du numeros de bin.
@@ -204,5 +204,5 @@
 
 //++
-void FunRan2D::Random(double& x, double& y)
+void FunRan2D::Random(r_8& x, r_8& y)
 //
 //	Tirage avec retour abscisse et ordonnee
@@ -211,5 +211,5 @@
 {
   x = ranX->Random();
-  int i = int(ceil(x));
+  int_4 i = int_4(ceil(x));
   //  FAILNIL(ranY[i]);  Ne compile pas $CHECK$ Reza 22/04/99
   y = ranY[i]->Random();
Index: trunk/SophyaLib/NTools/perandom.h
===================================================================
--- trunk/SophyaLib/NTools/perandom.h	(revision 1089)
+++ trunk/SophyaLib/NTools/perandom.h	(revision 1092)
@@ -13,27 +13,27 @@
 class FunRan : public Histo {
 public:
-  typedef double (*Func)(double);
-  FunRan(Func f, float xMin=0.0, float xMax=1.0, int nBin=100);
-  FunRan(double *tab, int nBin);
-  FunRan(double *tab, int nBin, float xMin, float xMax);
-  void IFunRan(double *tab, int nBin);
-  double Random(void);
-  int BinRandom(void);
+  typedef r_8 (*Func)(r_8);
+  FunRan(Func f, r_8 xMin=0.0, r_8 xMax=1.0, int_4 nBin=100);
+  FunRan(r_8 *tab, int_4 nBin);
+  FunRan(r_8 *tab, int_4 nBin, r_8 xMin, r_8 xMax);
+  void IFunRan(r_8 *tab, int_4 nBin);
+  r_8 Random(void);
+  int_4 BinRandom(void);
 };
 
 class FunRan2D EXC_AWARE {
 public:
-//  typedef double (*Func)(double, double);
-//  FunRan2D(Func f, float xMin=0.0, float xMax=1.0, int nBinX=100,
-//                   float yMin=0.0, float yMax=1.0, int nBinY=100);
-  FunRan2D(double *tab, int nBinX, int nBinY);
-  FunRan2D(double **tab, int nBinX, int nBinY);
+//  typedef r_8 (*Func)(r_8, r_8);
+//  FunRan2D(Func f, r_8 xMin=0.0, r_8 xMax=1.0, int_4 nBinX=100,
+//                   r_8 yMin=0.0, r_8 yMax=1.0, int_4 nBinY=100);
+  FunRan2D(r_8 *tab, int_4 nBinX, int_4 nBinY);
+  FunRan2D(r_8 **tab, int_4 nBinX, int_4 nBinY);
   ~FunRan2D();
-  void Random(double& x, double& y);
-  void BinRandom(int& x, int& y);
+  void Random(r_8& x, r_8& y);
+  void BinRandom(int_4& x, int_4& y);
 private:
   FunRan* ranX;
   FunRan** ranY;
-  int nx;
+  int_4 nx;
 };
 
